classdef CDemo < CDemoSim
    %PADDLEAPP Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
       skinRight;
       skinLeft;
       tactileAssistant;
       hasBeenTouched = 0;
    end
    
    methods
        function app = CDemo()
            app = app@CDemoSim();
            
            app.cntparams = {
                'MarkerTracker', '/CCDemo/MarkerTracker:i', '/MarkerTracker/marker:o', 'input';...
                'TactilesRight', '/CCDemo/TactilesRight:i', '/icub/skin/right_arm_comp', 'input';...
                'TactilesLeft', '/CCDemo/TactilesLeft:i', '/icub/skin/left_arm_comp', 'input';...
                'RandomHeadMovements', '/CCDemo/RandomHeadMovements/state:o', '/RandomHeadMovements/state:i', 'output';...
                'SimpleGazeCtrl', '/CCDemo/SimpleGazeCtrl/state:o', '/SimpleGazeCtrl/command', 'output';
                'ColorTrackerRed', '/CCDemo/pf3dTracker_R/input', '/pf3dTracker_R/data:o', 'input';
                'ColorTrackerYellow', '/CCDemo/pf3dTracker_Y/input', '/pf3dTracker_Y/data:o',  'input';
                
            };
        end
        
        function init(app)
            app.init@CDemoSim;
            
            app.tactileAssistant = TactileAssistant(app, app.gui.varPanel);
            app.skinRight = 0%;ICubSkin();
            app.skinRight.bodypart = 'righthand';
            app.skinLeft = 0;%ICubSkin();
            app.skinLeft.bodypart = 'lefthand';
            
            set(app.icubUI.uis.exeSim, 'Value', 0);
            set(app.icubUI.uis.exeRob, 'Value', 1);
        end
        
        function touched = istouched(app)
            [mbottle mstr] = yarpRead(app.cntUI.cnts.TactilesRight.port);
             %size(str2num(mstr))
            
            touched = norm(str2num(mstr))>400;%app.skinRight.touched(str2num(mstr));
            if touched
                if app.hasBeenTouched
                    touched = 0;
                    app.hasBeenTouched = 0;
                else
                    app.hasBeenTouched = 1;
                end
            end
        end
        
        function punished= ispunished(app)
            [mbottle mstr] = yarpRead(app.cntUI.cnts.TactilesLeft.port);
            punished = norm(str2num(mstr))>400;%app.skinLeft.touched(str2num(mstr));
        end
        
        function delete(app)
            delete(app.icubUI);
            delete(app.cntUI);
        end
        
    end
    
end

