classdef TactileAssistant < handle
    %GRASPASSISTANT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        app = [];
        parentup = [];
        uis = [];
        f = [];
        actTac='TactilesRight';
        data = [];
    end
    
    methods
        function ga = TactileAssistant(app, parentup)
            ga.app = app;
            
            if nargin < 2
                ga.f = figure('Visible','off','Position',[400,300,500,50]);
                set(ga.f,'MenuBar','none');
                set(ga.f,'Units','normalized');
                set(ga.f,'Name',class(ga));
                movegui(ga.f,'center');
                set(ga.f,'Visible','on');
                ga.parentup = ga.f;
            else
                ga.parentup = parentup;
            end
            
            ga.initUI();
        end
        
        function initUI(ga)
            
            list=[];
            ga.uis.hpop = uicontrol('Style', 'popup',...
                'String', list,...
                'Parent',ga.app.gui.varPanel,'Units','normalized','Position', [0 0.5 0.25 0.5],...
                'Callback', @ga.setTac,'Visible','off');
            ga.uis.record = uicontrol('Style', 'togglebutton',...
                'String','Record','Min',0,'Max',1,'Visible','off',...
                'Parent',ga.app.gui.varPanel,'Units','normalized','Position', [0 0.45 0.25 0.5],...
                'FontSize', 12,'Callback',@ga.record);
            ga.uis.calibrate = uicontrol('Style', 'pushbutton',...
                'String','calibrate','Visible','off',...
                'Parent',ga.parentup,'Units','normalized','Position', [0 0 0.25 0.5],...
                'FontSize', 12,'Callback',@ga.calibrate);
            ga.uis.display = uipanel('Title', 'Evaluation','visible','off',...
                'Units','normalized',...
                'Position', [0.25 0 0.75 1],...
                'Parent',ga.app.gui.varPanel,...
                'FontSize', 12, 'BackgroundColor', 'white');
        end
        function setTac(ga,src,evn)
            val = get(ga.uis.hpop,'Value');
            if val == 1
                ga.actTac = 'TactilesRight';
            elseif val == 2
                ga.actTac = 'TactilesLeft';
            end
        end
            
            function showUI(ga)
                
                list = [];
                if isfield(ga.app.cntUI.cnts, 'TactilesRight') && ga.app.cntUI.cnts.TactilesRight.isconnected()
                    list = 'TactilesRight';
                end
                if isfield(ga.app.cntUI.cnts, 'TactilesLeft') && ga.app.cntUI.cnts.TactilesLeft.isconnected()
                    list = [list '|TactilesLeft'];
                end
                set(ga.uis.hpop,'String', list);
                
                fields = fieldnames(ga.uis);
                for i = 1:numel(fields)
                    set(ga.uis.(fields{i}),'visible','on');
                end
            end
            
            function hideUI(ga)
                fields = fieldnames(ga.uis);
                for i = 1:numel(fields)
                    set(ga.uis.(fields{i}),'visible','off');
                end
            end
            
            function record(ga,src,evn)
                if get(src, 'Value')
                    ga.data = [];
                    while get(src, 'Value')
                        
                        eval(['[mbottle mstr] = yarpRead(ga.app.cntUI.cnts.' ga.actTac '.port);'])
                        ga.data = [ga.data; str2num(mstr)];
                        pause(0.01);
                    end
                    disp(['recorded ' num2str(size(ga.data,1)) ' samples']);
                    
                    %ga.app.skin.calibrate(data, ga.uis.display);
                end
            end
            
            function calibrate(ga,src,evn)
                %TESTING
                %load('../data/tactile_lefthand.mat');
                %ga.data = T;
                if strcmp(ga.actTac,'TactilesRight')
                    ga.app.skinRight.calibrate(ga.data, ga.uis.display);
                end
                
                if strcmp(ga.actTac,'TactilesLeft')
                    ga.app.skinLeft.calibrate(ga.data, ga.uis.display);
                end
            end
        end
        
    end
    
