close all;
clear all;

load('tactile.mat');

figure;
subaxis(2,2,1);
imagesc(T');
colormap gray;


S = sum(T,2)';

subaxis(2,2,2);
hist(S,20);

[Y t] = threshold(S);
t
ceil(t)

S(S < t) = 0;
S(S >= t) = 1;

subaxis(2,2,3);
imagesc(Y);
colormap gray;

subaxis(2,2,4);
imagesc(S);
colormap gray;



%     zeige    mittel   ring    klein    daumen   handflaeche
ps = {[1:12], [13:24], [25:36], [37:48], [49:60], [61:192]};
pstr = {'Zeigefinger', 'Mittelfinger', 'Ringfinger', 'Kleiner Finger', 'Daumen', 'Handflaeche'};
ts = zeros(1,6);
TP = zeros(size(T,1),6);

for f=1:length(ps)
    disp(pstr{f});
    figure;
    set(gcf,'Name',pstr{f});
    
    subaxis(2,2,1);
    imagesc(T(:,ps{f})');
    colormap gray;

    S = sum(T(:,ps{f}),2)';

    subaxis(2,2,2);
    hist(S,20);

    [Y ts(f)] = threshold(S);
    TP(:,f) = Y;
    ts(f)
    ceil(ts(f))

    S(S < ts(f)) = 0;
    S(S >= ts(f)) = 1;

    subaxis(2,2,3);
    imagesc(Y);
    colormap gray;

    subaxis(2,2,4);
    imagesc(S);
    colormap gray;
end

thresholdsPerFinger = ts;
save('thresholdsPerFinger.mat', 'thresholdsPerFinger');

figure;
subaxis(3,1,1);
imagesc(T');
colormap gray;
subaxis(3,1,2);
imagesc(TP');
subaxis(3,1,3);
TPC = ~(~TP(:,1) | ~TP(:,2) | ~TP(:,3) | ~TP(:,4) | ~TP(:,5) | ~TP(:,6));
imagesc(TPC');


