%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         *
%              ICub Head controller for the real iCub                     *
%                                                                         *
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;

icub = ICub('icub');
icub.open();
% set iCub to home posture
icub.driveToPosture('head', zeros(1,6));
pause(4);

ctrl = ICubHeadCtrl(icub);


%If ctrl.velctrl = 0 then position control mode : Be careful!
ctrl.velctrl = 0;

ctrl.open();

close all;


stop = 0;
changed= 1;

k = 0;
T = [];
Time = 0;
DQ =[];
Q = [];
P = [];
f=figure;
hold on; grid on ; box on;
resetWeightsButton = uicontrol(f, 'Style', 'togglebutton',...
    'String', 'STOP');
set(gcf, 'SelectionType', 'open');

while ~get(resetWeightsButton,'Value')
    
    button = get(gcf,'SelectionType');
    pause(0.01)
    tStart = tic;
    
    if strcmp(button, 'alt')
        stop = 1;
    end
    
    ctrl.updateTrackerInfo();
    
    [wtheta, htheta] = ctrl.updateCtrl();
   
    if ctrl.confidence
        % iCub is happy
        if changed
            ctrl.icub.setEmotion( 1);
            changed=0;
        end
        
        % To calculate the period of the loop, needed for plotting
        tElapsed = toc(tStart);
        k = k + 1;
        Time = Time + tElapsed;
        
        % Store data to be plotted
        P = [P [ctrl.Pleft ctrl.Pright]'];
        Q = [Q [wtheta htheta]' ];
        T = [ T ctrl.tElapsed ];
        DQ= [DQ ctrl.dq];
    else
        % iCub is neutral
        if ~changed
            ctrl.icub.setEmotion( 7);
        end
        changed=1;
    end
    
end %while

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            PLOT AND                      *
%                       GO TO HOME POSTURE                 *
%                                                          *
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ctrl.close();

icub.driveToPosture('head', zeros(1,6));
icub.driveToPosture('torso', zeros(1,3));
icub.close();

trackingPlot(DQ, P, Q, Time, k);




