classdef ICubSkin < handle
%skin = iCubSkin(bodypart)
%            if nargin > 0
%                skin.bodypart = bodypart;
%            end
    
    properties
        port = [];
             
        bodypart = 'righthand';
        %     zeige    mittel   ring    klein    daumen   handflaeche
        ps = {[1:12], [13:24], [25:36], [37:48], [49:60], [61:192]};
        pstr = {'Zeigefinger', 'Mittelfinger', 'Ringfinger', 'Kleiner Finger', 'Daumen', 'Handflaeche'};
        %ts = [2608 2576 2654 2593 2618 31521]; %left hand, strong
        %ts = [2674 2632 2720 2607 2526 31760]; %right hand, medium
        ts = [2674 2632 2720 2607 2526 21760]; %right hand, medium, no palm
    end
    
    methods
        function skin = iCubSkin(bodypart)
            if nargin > 0
                skin.bodypart = bodypart;
            end
            
            %load(['../data/' skin.bodypart]);
            %skin.ts = thresholdPerFinger;
        end
        
        function [T Y] = touched(skin, data)
            Y = zeros(size(data,1), length(skin.ps));
            for f=1:length(skin.ps)       
                S = sum(data(:,skin.ps{f}),2);
                
                S(S < skin.ts(f)) = 0;
                S(S >= skin.ts(f)) = 1;

                Y(:,f) = ~S;
            end
            T = sum(Y,2);
            T(T > 1) = 1;
        end
        
        function calibrate(skin, data, panel)
            for f=1:length(skin.ps)
                S = sum(data(:,skin.ps{f}),2)';
                [tmp skin.ts(f)] = threshold(S);
            end
            
            disp(['iCubSkin:' skin.bodypart ' thresholds are ' num2str(skin.ts)]);
            
            if nargin < 3
                panel = figure;
            end
            subplot(2,1,1,'parent', panel);
            cla(gca, 'reset');
            imagesc(data');
            axis([1 size(data,1) 1 size(data,2)]);
            colormap gray;
            subplot(2,1,2,'parent', panel);
            cla(gca, 'reset');
            imagesc(~skin.touched(data)');
            colormap gray;
        end
    end
    
end

