classdef YarpCntAssistant < handle
    %YARPCNTASSISTANT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        f = [];
        parentup = [];
        uis = [];

        cntparams = {};
        cnts = [];
    end
    
    methods
        function ui = YarpCntAssistant(cntparams, parentup)
            ui.cntparams = cntparams;
            
            if nargin < 2
                ui.f = figure('Visible','off','Position',[400,300,800,700]);
                set(ui.f,'MenuBar','none');
                set(ui.f,'Units','normalized');
                set(ui.f,'Name','YarpCntAssistant');
                movegui(ui.f,'center');
                set(ui.f,'Visible','on');
                ui.parentup = ui.f;
            else
                ui.parentup = parentup;
            end
            
            ui.initUI();
            ui.showUI();
        end
        
        function delete(ui)
            for i=1:length(ui.uis);
                ui.uis.disconnect();
            end
        end
        
        function initUI(ui)
            %ui.uis.panel = uipanel('Title', 'YarpCntAssistant',...
            %    'Units','normalized',...
            %    'Position', [0 0 1 1],...
            %    'Parent',ui.parentup,...
            %    'FontSize', 12, 'BackgroundColor', 'white');
            ui.uis.connect = uicontrol('Style', 'pushbutton',...
                'String','connect all','Parent',ui.parentup,'Units','normalized','Position', [0 0.29 0.2 0.29],...
                'FontSize', 12,'Callback',@ui.connect);
            ui.uis.disconnect = uicontrol('Style', 'pushbutton',...
                'String','disconnect all','Parent',ui.parentup,'Units','normalized','Position', [0 0 0.2 0.29],...
                'FontSize', 12,'Callback',@ui.disconnect);
            
            numCnts = size(ui.cntparams,1);
            for i=1:numCnts
                cmd = ['ui.cnts.' ui.cntparams{i,1} ' = YarpCntPanel(ui.parentup, [0.2+(i-1)*0.8/numCnts 0 0.8/numCnts 1]);'];
                eval(cmd);
                cmd = ['ui.cnts.' ui.cntparams{i,1} '.name = ''' ui.cntparams{i,1} ''';']; eval(cmd);
                cmd = ['ui.cnts.' ui.cntparams{i,1} '.portname = ''' ui.cntparams{i,2} ''';']; eval(cmd);
                cmd = ['ui.cnts.' ui.cntparams{i,1} '.remoteportname = ''' ui.cntparams{i,3} ''';']; eval(cmd);
                cmd = ['ui.cnts.' ui.cntparams{i,1} '.cntrole = ''' ui.cntparams{i,4} ''';']; eval(cmd);
            end
        end
        
        function b = isconnected(ui)
            b = 1;
            if ~isempty(ui.cnts)
                fields = fieldnames(ui.cnts);
                for i=1:numel(fields)
                    b = b && ui.cnts.(fields{i}).isconnected();
                    %tmp = ui.uis.(fields{i});
                    %if isa(tmp, 'YarpCntPanel')
                        %b = b ^ tmp.isconnected();
                    %end
                end
            else
                b = 0;
            end
        end
        
        function connect(ui,src,evn)
            if ~isempty(ui.cnts)
                fields = fieldnames(ui.cnts);
                for i=1:numel(fields)
                    ui.cnts.(fields{i}).connect();
                end
            end
        end
        
        function disconnect(ui,src,evn)
            if ~isempty(ui.cnts)
                fields = fieldnames(ui.cnts);
                for i=1:numel(fields)
                    ui.cnts.(fields{i}).disconnect();
                end
            end
        end
        
        function showUI(ui)
            fields = fieldnames(ui.uis);
            for i=1:numel(fields)
                set(ui.uis.(fields{i}),'visible','on');
            end
            if ~isempty(ui.cnts)
                fields = fieldnames(ui.cnts);
                for i=1:numel(fields)
                    ui.cnts.(fields{i}).showUI();
                end
            end
        end
        
        function hideUI(ui)
            fields = fieldnames(ui.uis);
            for i=1:numel(fields)
                set(ui.uis.(fields{i}),'visible','off');
            end
            if ~isempty(ui.cnts)
                fields = fieldnames(ui.cnts);
                for i=1:numel(fields)
                    ui.cnts.(fields{i}).hideUI();
                end
            end
        end
    end
    
end

