clear;
expFolder = '/Users/Shared/work/Research/2ndPhase/NeuralConditioningInRobots/Demo/matlab/neuralnet/res/CCautoBrief/';
disp(['Retriving data for the experiment in folder: ' expFolder])

warning('off','MATLAB:class:cannotUpdateClass');
warning('off','MATLAB:load:classNotFound');
warning('off','MATLAB:RandStream:loadobj:LoadError');

% cycle through the experiment-directories if they exist.
%cd expFolder;
for i = 1:10
    filename = [expFolder 'CCautoBrief_r178_s' num2str(3110 + i) '.mat'];
    disp(filename);
    if (exist(filename) > 0)
        try
            load(filename);
        catch
        end
        disp(['Getting data from run with seed' num2str(app.par.seed)]);
        data(i,:,:) = app.netCC.log.synapsesS;
    else
        disp(['No data file found for run' num2str(i)]);
    end
end

% get the CS in front

dataCSinfront = data;
dataCSinfront(:,:,1) = data(:,:,5);
dataCSinfront(:,:,5) = data(:,:,1);

for i = 1:10
    dataCS(i,:) = dataCSinfront(i,:,1);
    for j=2:9
        dataNCS((i-1)*8+j-1,:) = dataCSinfront(i,:,j);
    end
end


totsteps = 36000;
samples = 40;
interval = totsteps/samples;
dataNCSavg = zeros(80,samples);
dataCSavg = zeros(10,samples);

for i = 1:80
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        dataNCSavg(i,count) = mean(dataNCS(i,j:(j+interval-1)),2); 
    end
end

for i=1:10
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        dataCSavg(i,count) = mean(dataCS(i,j:(j+interval-1)),2); 
    end
    
end

figure;


boxplot(dataCSavg(:,:),'plotstyle','compact','colors','b');
set(gca,'XTickLabel',{' '});
hold on;
boxplot(dataNCSavg(:,:),'plotstyle','compact','colors',[0 0.5 0]);
set(gca,'XTickLabel',{' '}, 'Ylim',[-0.05 1.05]);
grid;


clear expFolder
clear totsteps
clear samples
clear interval;
