clear;
expFolder = '/Users/Shared/work/Research/2ndPhase/NeuralConditioningInRobots/Demo/matlab/neuralnet/res/OCauto_5C/';
disp(['Retriving data for the experiment in folder: ' expFolder])

% cycle through the experiment-directories if they exist.
%cd expFolder;
countA = 1;
countB = 1;
nrOfRuns = 10;
nrOfColours = 1;
nrASSOCpathways = nrOfRuns * nrOfColours;
nrNONASSOCpathways = nrOfRuns * 7;
 
for i = 1:nrOfRuns
    filename = [expFolder 'OCauto5Colors_r183_s' num2str(3110 + i) '.mat'];
    disp(filename);
    if (exist(filename) > 0)
        load(filename);
        disp(['Getting data from run with seed' num2str(app.par.seed)]);
        for j = 1:nrOfColours
            dataASSOC(countA,:) = app.netOC.log.synapsesStoO{j}(:,j);
            countA = countA + 1;
            for k = 1:8
                if k ~= j
                dataNONASSOC(countB,:) = app.netOC.log.synapsesStoO{j}(:,k);
                countB = countB + 1;
                end
            end
        end
    else
        disp(['No data file found for run' num2str(i)]);
    end
end


totsteps = app.par.simTime/app.par.samplingTime;
samples = 40;
interval = totsteps/samples;
dataASSOCavg = zeros(nrASSOCpathways,samples);
dataNONASSOCavg = zeros(nrNONASSOCpathways,samples);

for i = 1:nrNONASSOCpathways
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        dataNONASSOCavg(i,count) = mean(dataNONASSOC(i,j:(j+interval-1)),2); 
    end
end

for i=1:nrASSOCpathways
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        dataASSOCavg(i,count) = mean(dataASSOC(i,j:(j+interval-1)),2); 
    end
    
end

figure;


boxplot(dataASSOCavg(:,:),'plotstyle','compact','colors','b');
set(gca,'XTickLabel',{' '})
hold on;
boxplot(dataNONASSOCavg(:,:),'plotstyle','compact','colors',[0 0.5 0]);
set(gca,'XTickLabel',{' '})
grid;


clear expFolder
clear totsteps
clear samples
clear interval;
