% This script samples data taking the average over a 2 min interval 
% The data set is 10 CC experiments, each having 9 stimuli, one of which is
% the CS. There are therefore 10 CS and 80 non-CS stimuli

totsteps = 36000;
samples = 40;
interval = totsteps/samples;
allNCSavg = zeros(80,samples);
allCSavg = zeros(10,samples);

for i = 1:80
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        allNCSavg(i,count) = mean(allNCS(i,j:(j+interval-1)),2); 
    end
end

for i=1:10
    count = 0;
    for j = 1:interval:totsteps
        count = count + 1;
        allCSavg(i,count) = mean(allCS(i,j:(j+interval-1)),2); 
    end
    
end

figure;


boxplot(allCSavg(:,:),'plotstyle','compact','colors','b');
set(gca,'XTickLabel',{' '})
hold on;
boxplot(allNCSavg(:,:),'plotstyle','compact','colors',[0 0.5 0]);
set(gca,'XTickLabel',{' '})
grid;

