classdef RPSStateMachineUI < handle
    %GRASPASSISTANT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties(SetObservable)
        app = [];
        parentup = [];
        uis = [];
        state = 0;
        f=0;
    end
    events
        StateChange;
    end
    methods
        function ga = RPSStateMachineUI(app, parentup)
            ga.app = app;
            
            if ~exist('parentup','var')
                ga.f = figure('Visible','off','Position',[400,300,500,50]);
                set(ga.f,'MenuBar','none');
                set(ga.f,'Units','normalized');
                set(ga.f,'Name','StateMachine');
                movegui(ga.f,'center');
                set(ga.f,'Visible','on');
                ga.parentup = ga.f;
            else
                ga.parentup = parentup;
            end

            ga.initUI();            
        end
        
        function initUI(ga)
            app = ga.app;
            ga.uis.connect = uicontrol('Style', 'togglebutton',...
                'String','Connections','Min',0,'Max',1,...
                'Parent',ga.parentup,'Units','normalized','Position', [0 0 0.5 1],...
                'FontSize', 12,'Callback',@app.connect);
            ga.uis.running = uicontrol('Style', 'togglebutton',...
                'String','Run System','Min',0,'Max',1,...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0 0.5 1],...
                'FontSize', 12,'Callback',@app.running);
        end
        
        
        function setState(ga, state)
           ga.app.status = state;
           switch state
               case ga.app.PRECONNECT
                   fields = fieldnames(ga.uis);
                   for i=1:numel(fields)
                       set(ga.uis.(fields{i}),'Enable','off');
                       set(ga.uis.(fields{i}),'Value',0);
                   end
                   set(ga.uis.connect,'Enable','on');
                   set(ga.uis.connect,'Value',0);
                  
                   ga.app.cntUI.hideUI();
                   
               case ga.app.CONNECTING
                   fields = fieldnames(ga.uis);
                   for i=1:numel(fields)
                       set(ga.uis.(fields{i}),'Enable','off');
                       set(ga.uis.(fields{i}),'Value',0);
                   end
                   set(ga.uis.connect,'Enable','on');
                   set(ga.uis.connect,'Value',1);
                   
                   ga.app.cntUI.showUI();
                   
               case ga.app.WAITFORSTART
                   ga.app.cntUI.hideUI();
                   set(ga.uis.connect,'Enable','on');
                   set(ga.uis.connect,'Value',0);

                   %if ga.app.icubUI.isconnected() && ga.app.cntUI.cnts.MVITE_head.isconnected()
                   %    set(ga.uis.performaction, 'Enable', 'on');
                   %else
                   %    set(ga.uis.performaction, 'Enable', 'off');
                   %end
                   
                   if ga.app.cntUI.isconnected() %DEBUG mode
                   %if ga.app.icubUI.isconnected() && ga.app.cntUI.isconnected()
                       set(ga.uis.running, 'Enable', 'on');
                   else
                       set(ga.uis.running, 'Enable', 'off');
                       set(ga.uis.running, 'Value', 0);
                   end
                   
               case ga.app.RUNNING
                   fields = fieldnames(ga.uis);
                   for i=1:numel(fields)
                       set(ga.uis.(fields{i}),'Enable','off');
                       set(ga.uis.(fields{i}),'Value',0);
                   end
                   set(ga.uis.running,'Enable','on');
                   set(ga.uis.running,'Value',1);
                   
                   %ga.app.simplegazeAssistant.showUI();
           end
        end
        
    end
end
    
