classdef rpsIOAutoSim < rpsIO
       
    methods
        function app = rpsIOAutoSim()
            app = app@rpsIO();
            
            %% Paramers of the simulation
            app.ser.maxRewardDelay          = 3;   % maximum reward delay in auto-mode
            app.par.stimulusEvery           = 15;  % the simulation starts a new trial every
            
            %% Service variables
            app.ser.rewardToBeGiven         = 0;
            app.ser.stepsToReward           = -1;
            app.ser.stimulusEpisode         = 0;
            
        end
        
        function readStimuli(app)
            % set random stimuli at regular intervals
            if mod(app.ser.currentStep,round(app.par.stimulusEvery/app.par.samplingTime)) == 1
                app.ser.stimulusEpisode = app.ser.stimulusEpisode + 1;
                app.ser.currentOCStimulus = app.netOC.myrandi(1,1,1,app.par.nrOCStimuli);
                app.OCstimuli(app.ser.currentOCStimulus) = 1;
            end
            
            % countdown for reward in the future
            if app.ser.stepsToReward == 0
                app.currentModulation = app.ser.rewardToBeGiven;
            end
            app.ser.stepsToReward = app.ser.stepsToReward - 1;
            
        end
        
        function readOutput(app)
            
            app.readOutput@rpsIO;
            
            if app.ser.actionCompleted == 1
                % in simulation there is no operator that gives a delayed
                % reward, so this function sets a countdown
                app.assignFutureRewardSim();

            end
        end
        
        function assignFutureRewardSim(app)
            
            if app.ser.whoWins == mod(app.ser.currentOCStimulus - 1,3) + 1;
                
%                disp(['wins ' num2str(app.ser.whoWins) ' currentStimulus ' num2str(currentOCStimulus)]);               
                app.ser.stepsToReward = round( app.ser.maxRewardDelay / app.par.samplingTime * rand(app.netOC.stream,1)) +  1;
                app.ser.rewardToBeGiven = app.par.positiveReward;
                disp(['steps to reward: ' num2str(app.ser.stepsToReward) ' reward is ' num2str(app.ser.rewardToBeGiven) ]);
            else
                app.ser.stepsToReward = round( app.ser.maxRewardDelay / app.par.samplingTime * rand(app.netOC.stream,1)) +  1;
                app.ser.rewardToBeGiven = app.par.negativeReward;
            end
        end
    end
end
