function getRSBed()
%RSBMATLABPRELIMINARIES checks whether all necessary preliminaries for 
% using rsb and matlab are done, and, if not, processes them.

prefix = '/vol/amarsi/trunk/32bit/';

% check first, if all preliminaries are already done
rsbed = 0;
testPath = [prefix 'share/java/rsb.m.jar'];
jcp = javaclasspath;
if ismember(testPath, jcp)
    rsbed = 1;
end

% otherwise add all necessary java paths ...
if ~rsbed
    javaaddpath('/usr/share/java/protobuf.jar');
    javaaddpath([prefix 'share/java/rsb-0.8.0.jar']);
    javaaddpath([prefix 'share/java/rsb.m.jar']);
    javaaddpath([prefix 'share/java/rstsandbox.jar']);
    javaaddpath([prefix 'share/java/rst.jar']);

    % ... and register all converters.
    rsb.matlab.ConverterRegistration.register()
end

%dont forget to start
% spread -n localhost

end
