echo "using ICUB_ROOT="$ICUB_ROOT

SVNDIR=$PWD/../

echo "using SVNDIR="$SVNDIR

STME=1

ICUBSIM=0
MOTION=0

SERVICE="yarpserver"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
    gnome-terminal -t "$SERVICE" -x bash -c "$SERVICE"
	sleep $STME
fi


if [ $ICUBSIM = 1 ] ; then
SERVICE="iCub_SIM"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" -x bash -c "ICUB_ROOT=$ICUB_ROOT $SERVICE --from simConfig/simulator.ini"
	sleep $STME
fi
fi


SERVICE="Grabber"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" -x bash -c "yarpdev --device opencv_grabber --width 320 --height 240 --name /grabber --camera 0"
	sleep 3
fi


SERVICE="RPSDetector"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" --working-directory=$SVNDIR/Demo/workspace/Ropsci -x bash -c "./build/Ropsci --from conf/Ropsci.ini"
	sleep 3
fi


echo "Connect grabber to detector"
yarp connect /grabber /Ropsci/image:i


SERVICE="MarkerTracker"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" --working-directory=$SVNDIR/Demo/workspace/MarkerTracker -x bash -c "./build/MarkerTracker --context ./conf"
	sleep $STME
	sleep $STME
fi

yarp connect /grabber /MarkerTracker/image:i



SERVICE="RopsciSequencer"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" --working-directory=$SVNDIR/Demo/workspace/RopsciSequencer -x bash -c "./build/RopsciSequencer --from conf/RopsciSequencer.ini"
	sleep $STME
fi


SERVICE="ESpeakServer"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
    echo "$SERVICE is not running, starting it"
	gnome-terminal -t "$SERVICE" --working-directory=$SVNDIR/Demo/workspace/ESpeakServer -x bash -c "./build/ESpeakServer --from conf/ESpeakServer.ini"
	sleep $STME
fi


echo "Connect RopsciSequencer to ESpeakServer"
yarp connect /RopsciSequencer/es:o /ESpeakServer/command  

if [ $MOTION = 1 ] ; then
SERVICE="MVITE"
if ps ax | grep -v grep | grep $SERVICE > /dev/null
then
    echo "$SERVICE service running, everything is fine"
else
	gnome-terminal  -t "$SERVICE" -x bash -c "$SVNDIR/Demo/workspace/MVITE/build/MVITE --from $SVNDIR/Demo/workspace/MVITE/conf/MVITE_SimFast.ini"
	sleep $STME
fi


echo "Connect RopsciSequencer to MVITE"
yarp connect /RopsciSequencer/jas:o /MVITE/command  
fi


#start matlab and execute startRPS

