/**
 * @file ESpeakServerThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _ESpeakServer_THREAD_H_
#define _ESpeakServer_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>
#include <cstdlib>

class ESpeakServerModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class ESpeakServerThread : public yarp::os::Thread {
private:
	ESpeakServerModule* module;

public:
   /**
    * constructor.
    * 
    */
   ESpeakServerThread(ESpeakServerModule* module);

   /**
    * destructor.
    */
   ~ESpeakServerThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_ESpeakServer_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
