
/**
 * @file ESpeakServerThread.cpp
 * @brief implementation of the ESpeakServerThread (for the ESpeakServer) methods.
 */

#include <iCub/ESpeakServerThread.h>
#include <iCub/ESpeakServerModule.h>
#include <string.h>

using namespace yarp::os;
using namespace yarp::sig;
using namespace std;


ESpeakServerThread::ESpeakServerThread(ESpeakServerModule* module) {
	this->module = module;
}

bool ESpeakServerThread::threadInit() {

    return true;
}

void ESpeakServerThread::run() {
  int time;
  
  /*** The main loop. It processes a frame per period ***/
  while (isStopping() != true) { // the thread continues to run until isStopping() returns true
       
    //inform world of current status
	/*Bottle& output = this->module->statusOut.prepare();
	output.clear();
	output.addInt(this->module->speaking);
	this->module->statusOut.write();*/

	//received new text
	if (this->module->receivednewtext) {
		this->module->receivednewtext = false;
		this->module->speaking = true;
		std::string cmd = "espeak ";
		cmd += this->module->voice;
		cmd += " \"" + this->module->text + "\"";
		std::cout << "[" << this->module->getName() << "] " << "calling " << cmd << " ... " << std::endl;
		system(cmd.c_str());
		this->module->text = "";
		this->module->speaking = false;
		std::cout << "done!" << std::endl;
	}

	sleep(0.1);

  }  //while
}


void ESpeakServerThread::threadRelease() {
   /* for example, delete dynamically created data-structures */
}

void ESpeakServerThread::onStop() {

}


