/**
 * @file MVITEThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _MVITE_THREAD_H_
#define _MVITE_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>

class MVITEModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class MVITEThread : public yarp::os::Thread {
private:
	MVITEModule* module;

public:
   /**
    * constructor.
    * 
    */
   MVITEThread(MVITEModule* module);

   /**
    * destructor.
    */
   ~MVITEThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_MVITE_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
