
/**
 * @file MVITEThread.cpp
 * @brief implementation of the MVITEThread (for the MVITE) methods.
 */

#include <iCub/MVITEThread.h>
#include <iCub/MVITEModule.h>
#include <string.h>

using namespace yarp::os;
using namespace yarp::sig;
using namespace std;


MVITEThread::MVITEThread(MVITEModule* module) {
	this->module = module;
}

bool MVITEThread::threadInit() {

    return true;
}

void MVITEThread::run() {

  /*** The main loop. It processes a frame per period ***/
  while (isStopping() != true) { // the thread continues to run until isStopping() returns true

	this->module->process();
  }  //while
}


void MVITEThread::threadRelease() {
   // for example, delete dynamically created data-structures
}

void MVITEThread::onStop() {
	cout<<"on stop"<<endl;
	module->ivel->stop();
}


