/**
 * @file blobTrackerThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _RANDOMMOVEMENT_THREAD_H_
#define _RANDOMMOVEMENT_THREAD_H_

#include <yarp/os/all.h>
#include "iCub/RandomMovementModule.h"


/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class RandomMovementModule;
class RandomMovementThread : public yarp::os::Thread {
private:
	RandomMovementModule* module;
public:
   /**
    * constructor.
    * 
    */
	RandomMovementThread(RandomMovementModule* module);

   /**
    * destructor.
    */
   ~RandomMovementThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();


   	
};


#endif  //_MARKERTRACKER_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
