#pragma once

class ColorRule {
private:
	unsigned int red_min, green_min, blue_min, max_min_span, min_value;
public:
	ColorRule(unsigned int rm, unsigned int gm, unsigned int bm,
			unsigned int mms, unsigned int mv) :
			red_min(rm), green_min(gm), blue_min(bm), max_min_span(mms), min_value(
					mv) {
	}
	;

	inline bool match(const unsigned char red, const unsigned char green,
			const unsigned char blue, const unsigned char max,
			const unsigned char min) const {
		return red > red_min && green > green_min && blue > blue_min
				&& (unsigned int) (max - min) > max_min_span
				&& (unsigned int) abs(red - green) > min_value && red > green
				&& red > blue;
	}
};

