#pragma once

#include <vector>
#include <string>
#include <cstring>
//#include <math.h>

#include <nemo/Vector.h>
#include <nemo/Matrix.h>

static nemo::RealMatrix nemoReadRealMatrix(std::string filename) {
	// try to open file
	std::ifstream file(filename.c_str(), std::ios::in); //|std::ios::binary);
	if (!file.is_open()) {
		return nemo::RealMatrix();
	}

	unsigned int r, c;
	double tmp;
	file >> r;
	file >> c;
	nemo::RealMatrix m(nemo::dim(r, c));
	for (unsigned int i=0; i<m.rows(); i++) {
		for (unsigned int j=0; j<m.cols(); j++) {
			file >> tmp;
			m(i,j) = tmp;
		}
	}
	file.close();
	return m;
}

static nemo::RealVector nemoReadRealVector(std::string filename) {
	// try to open file
	std::ifstream file(filename.c_str(), std::ifstream::in); //std::ios::in|std::ios::binary);
	if (!file.is_open()) {
		return nemo::RealVector();
	}

	unsigned int d;
	double tmp;
	file >> d;
	if (d) {
		nemo::RealVector v(nemo::dim(d));
		for (unsigned int i=0; i<v.dimension(); i++) {
			file >> tmp;
			v[i] = tmp;
		}
		file.close();
		return v;
	} else {
		file.close();
		return nemo::RealVector();
	}
}

static bool nemoWriteRealVector(std::string filename, nemo::RealVector v) {
	// try to open file
	std::ofstream file(filename.c_str()); //std::ios::in|std::ios::binary);
	if (!file.is_open()) {
		return false;
	}
	file << v.dimension() << std::endl;
	for (unsigned int i=0; i<v.dimension(); i++)	file << v[i] << " ";
	file.close();
	return true;
}


