/**
 * @file RopsciThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _Ropsci_THREAD_H_
#define _Ropsci_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>


class RopsciModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class RopsciThread : public yarp::os::Thread {
private:
	RopsciModule* module;

public:
   /**
    * constructor.
    * 
    */
   RopsciThread(RopsciModule* module);

   /**
    * destructor.
    */
   ~RopsciThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_Ropsci_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
