/**
 * @file main.cpp
 * @brief main code for your module. This shows up in the list of files.
 */

#include "iCub/RopsciModule.h" 

using namespace yarp::os;
using namespace yarp::sig;


int main(int argc, char * argv[]) {
   /* initialize yarp network */ 
   Network yarp;
   /* create your module */
   RopsciModule module;
   
   /* prepare and configure the resource finder */
   ResourceFinder rf;
   rf.setVerbose(true);
   rf.setDefaultConfigFile("Ropsci.ini"); //overridden by --from parameter
   rf.setDefaultContext("/conf");   //overridden by --context parameter
   rf.configure("ICUB_ROOT", argc, argv);
 
   /* run the module: runModule() calls configure first and, if successful, it then runs */
   module.runModule(rf);

   return 0;
}

