/**
 * @file RopsciSequencerThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _RopsciSequencer_THREAD_H_
#define _RopsciSequencer_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>

class RopsciSequencerModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class RopsciSequencerThread : public yarp::os::Thread {
private:
	RopsciSequencerModule* module;

public:
   /**
    * constructor.
    * 
    */
   RopsciSequencerThread(RopsciSequencerModule* module);

   /**
    * destructor.
    */
   ~RopsciSequencerThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_RopsciSequencer_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
