/**
 * @file SimpleGazeCtrlThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _SimpleGazeCtrl_THREAD_H_
#define _SimpleGazeCtrl_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>

class SimpleGazeCtrlModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class SimpleGazeCtrlThread : public yarp::os::Thread {
private:
	SimpleGazeCtrlModule* module;

public:
   /**
    * constructor.
    * 
    */
   SimpleGazeCtrlThread(SimpleGazeCtrlModule* module);

   /**
    * destructor.
    */
   ~SimpleGazeCtrlThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_SimpleGazeCtrl_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
