
/**
 * @file SimpleGazeCtrlThread.cpp
 * @brief implementation of the SimpleGazeCtrlThread (for the SimpleGazeCtrl) methods.
 */

#include <iCub/SimpleGazeCtrlThread.h>
#include <iCub/SimpleGazeCtrlModule.h>
#include <string.h>

using namespace yarp::os;
using namespace yarp::sig;
using namespace std;


SimpleGazeCtrlThread::SimpleGazeCtrlThread(SimpleGazeCtrlModule* module) {
	this->module = module;
}

bool SimpleGazeCtrlThread::threadInit() {

    return true;
}

void SimpleGazeCtrlThread::run() {
  int oldState = module->state;
  while (isStopping() != true) {
	if (module->state == SimpleGazeCtrlModule::IDLE) {
		if (oldState != module->state) {
			printf("switched to idle state\n");
			module->dqheadOld.zero();
			module->ivel->velocityMove(module->dqheadOld.data());

			module->ivel->stop();
			sleep(0.5);
			module->ivel->stop();

			oldState = module->state;
		}
		sleep(0.1);
	} else {
		if (oldState != module->state) {
			printf("switched to running state\n");
			oldState = module->state;
			module->dqheadOld.zero();
		}
		module->updateModule();
		sleep(0.05);
	}
  }  //while
}


void SimpleGazeCtrlThread::threadRelease() {
   /* for example, delete dynamically created data-structures */
}

void SimpleGazeCtrlThread::onStop() {

}


