
/**
 * @file iCubTemplateModuleThread.cpp
 * @brief implementation of the iCubTemplateModuleThread (for the iCubTemplateModule) methods.
 */

#include <iCub/iCubTemplateModuleThread.h>
#include <iCub/iCubTemplateModuleModule.h>
#include <string.h>

using namespace yarp::os;
using namespace yarp::sig;
using namespace std;


iCubTemplateModuleThread::iCubTemplateModuleThread(iCubTemplateModuleModule* module) {
	this->module = module;
}

bool iCubTemplateModuleThread::threadInit() {

    return true;
}

void iCubTemplateModuleThread::run() {
  int time;
  
  /*** The main loop. It processes a frame per period ***/
  while (isStopping() != true) { // the thread continues to run until isStopping() returns true
       
    //frame = imagePortIn.read(true);
    //if(frame!=0) ...
      
    //time = clock();

	//Bottle output;
	Bottle& output = this->module->portOut.prepare();
	output.clear();
	output.addInt(0);
	output.addString("empty");
	//cout << "writing " << output.toString().c_str() << endl;
	this->module->portOut.write();
     
    //time = clock() - time;
    //std::cout<< ((float)time)/CLOCKS_PER_SEC << " s per iteration" << endl;

  }  //while
}


void iCubTemplateModuleThread::threadRelease() {
   /* for example, delete dynamically created data-structures */
}

void iCubTemplateModuleThread::onStop() {

}


