/**
 * @file iCubTemplateModuleThread.h
 * @brief this file contains the definition of an additional thread that does the job for the main module.
 */

#ifndef _iCubTemplateModule_THREAD_H_
#define _iCubTemplateModule_THREAD_H_

#include <yarp/sig/all.h>
#include <yarp/os/all.h>

class iCubTemplateModuleModule;

/**
 * An instance of the class blobTrackerThread processes frames from the camera and estimate the position of the target.
 */
class iCubTemplateModuleThread : public yarp::os::Thread {
private:
	iCubTemplateModuleModule* module;

public:
   /**
    * constructor.
    * 
    */
   iCubTemplateModuleThread(iCubTemplateModuleModule* module);

   /**
    * destructor.
    */
   ~iCubTemplateModuleThread() {}

   bool threadInit();     
   void threadRelease();
   void run(); // run the thread. It is the main function
   void onStop();

};


#endif  //_iCubTemplateModule_THREAD_H_

//----- end-of-file --- ( next line intentionally left blank ) ------------------
