classdef rpsRobot < rpsRobotSim
    %PADDLEAPP Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
       skinRight;
       skinLeft;
       touchThreshold = 200;
    end
    
    methods
        function app = rpsRobot()
            app = app@rpsRobotSim();
            
            app.cntparams = {
                 'MarkerTracker', '/CCDemo/MarkerTracker:i', '/MarkerTracker/marker:o', 'input';...
                 'ESpeakServer', '/CCDemo/espeak', '/ESpeakServer/command', 'output';
                'TactilesRight', '/CCDemo/TactilesRight:i', '/icub/skin/right_arm_comp', 'input';...
                'TactilesLeft', '/CCDemo/TactilesLeft:i', '/icub/skin/left_arm_comp', 'input';...
                'RopsciDetector', '/CCDemo/detector', '/Ropsci/rps:o', 'input';
                'RopsciSequencer', '/CCDemo/sequencer', '/RopsciSequencer/command', 'output';
                'RopsciSequencer_status', '/CCDemo/sequencerstatus', '/RopsciSequencer/status:o', 'input';
                %'MVITE_head', '/CCDemo/MVITE_head:o', '/MVITE/head/state:i', 'output';...
            };
        end
        
        function init(app)
            app.init@rpsRobotSim;

            app.skinRight.bodypart = 'righthand';
            app.skinLeft.bodypart = 'lefthand';
            
            set(app.icubUI.uis.exeSim, 'Value', 0);
            set(app.icubUI.uis.exeRob, 'Value', 1);
            app.icubUI.icubexe={0,1};
        end
        
        function rewarded = isrewarded(app)
            [mbottle mstr] = yarpRead(app.cntUI.cnts.TactilesLeft.port);
            rewarded = norm(str2num(mstr)) > app.touchThreshold;
            
        end
        
        function punished = ispunished(app)
            [mbottle mstr] = yarpRead(app.cntUI.cnts.TactilesRight.port);
            punished = norm(str2num(mstr))>app.touchThreshold;
            
        end
        
        function delete(app)
            delete(app.icubUI);
            delete(app.cntUI);
        end
        
    end
    
end

